{-# LANGUAGE OverloadedStrings #-}

module Main where

import Network.HTTP.Client (newManager)
import Network.HTTP.Client.TLS (tlsManagerSettings)
import Servant.Client

import HAL (runStructureRequest)
import HAL.Client
import HAL.Doc
import Tree

main :: IO ()
main = do
  manager' <- newManager tlsManagerSettings
  res <- runStructureRequest $ Just "parentDocid_i:302102"
  case res of
    (Left err) -> print err
    (Right val) -> print val

{-
main :: IO ()
main = do
  rootRes <- runHalAPIClient $ structure (Just $ fqRootDoc) (Just "docid, parentDocid_i, label_s") (Just 10000)
  case rootRes of
    (Left err) -> print err
    (Right val) -> do
      childrenRes <- runHalAPIClient $ structure (Just $ fqParentDoc) (Just "docid, parentDocid_i, label_s") (Just 10000)
      case childrenRes of
        (Left err2) -> print err2
        (Right val2) -> do
          children <- fetchChildren $ val2 ^. docs
          let trees = buildTree 0 children <$> (val ^. docs)
          let noDuplicateTrees = noDuplicateTree <$> trees
          mapM_ putStrLn $ formatTree <$> noDuplicateTrees
  where fqParentDoc =
          "parentDocid_i:(302102 || 469216 || 6279 || 224096 || 144103 || 497330 || 84538 || 301262 || 481355 || 29212 || 301442 || 542824 || 300362 || 352124 || 300104 || 421532 || 301492)"
        fqRootDoc =
          "docid:(302102 || 469216 || 6279 || 224096 || 144103 || 497330 || 84538 || 301262 || 481355 || 29212 || 301442 || 542824 || 300362 || 352124 || 300104 || 421532 || 301492)"
-}
