{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE OverloadedStrings #-}

module HAL.Doc where

import GHC.Generics

import Data.Aeson ((.:), (.:?), (.!=), Value(..), ToJSON, FromJSON(..), encode)
import Data.Default
import Data.Text (pack, Text)

import Servant.API (ToHttpApiData(..))


data Doc = Doc
  {
    _docid :: Int,
    _label_s :: Maybe Text,
    _parentDocid_i :: [Text]
  } deriving (Generic)

instance Default Doc where
  def = Doc def def def

instance FromJSON Doc where
  parseJSON (Object o) = Doc <$>
    (o .: "docid")
    <*> (o .:? "label_s")
    <*> (o .:? "parentDocid_i" .!= [])

instance ToHttpApiData Doc where
  toUrlPiece _ = "docid,label_s,parentDocid_i"

instance Show Doc where
  show (Doc id label _) = show label
    <> "(" <> show id <> ")"

